#    -    .

proc maf:readpl {} {
	global mafs mafmsg mafnicks
	putlog "   "
if {[array exist mafnicks]} {unset mafnicks}
if {[file exist $mafs(plfile)]} {
	set fid [open $mafs(plfile) r]
	while {![eof $fid]} {
		gets $fid l
		if {[llength $l]>2} {
			set mafnicks([lindex $l 0]) [lrange $l 1 end]
			}
		}
	close $fid	
	}
}

proc maf:savepl {} {
	global mafs mafmsg mafnicks
	set fid [open $mafs(plfile) w]	
	if {[array exists mafnicks]} {
  		foreach e [array names mafnicks] {puts $fid "{$e} $mafnicks($e)"}
 		}
 	close $fid
	if {![file exists $mafs(plfile).backup]} {
  	file copy -force $mafs(plfile) $mafs(plfile).backup
	 }
	putlog "Saving players info"
	}	
	
proc maf:readstat {} {
	global mafs mafmsg mafnicks mafstat
	putlog " "
if {[array exist mafstat]} {unset mafstat}
if {[file exist $mafs(stfile)]} {
	set fid [open $mafs(stfile) r]
	while {![eof $fid]} {
		gets $fid l
		if {[llength $l]>2} {
			set mafstat([lindex $l 0]) [lrange $l 1 end]
			}
		}
	close $fid	
	}
}

proc maf:savest {} {
	global mafs mafmsg mafnicks mafstat
	set fid [open $mafs(stfile) w]	
	if {[array exists mafstat]} {
  		foreach e [array names mafstat] {puts $fid "{$e} $mafstat($e)"}
 		}
 	close $fid
	if {![file exists $mafs(stfile).backup]} {
  	file copy -force $mafs(stfile) $mafs(stfile).backup
	 }
	putlog "Saving players stat"
	}	

proc maf:killtimers {} {
foreach e [utimers] {if {[string first "maf:" $e]!=-1} {killutimer [lindex $e 2]}}
		}	

#proc maf:say {w} {
#  global mafs
#  puthelp "PRIVMSG $mafs(curchannel) :$w"
#} 


proc maf:say {w} {
  global mafs msglist
  randmsg
  set msglist [lappend msglist "PRIVMSG $mafs(curchannel) :$w"]
} 


proc maf:say2 {c w} {
global mafs
  puthelp "PRIVMSG $c :$w"
	}

proc maf:not {w} {
 global mafs
 puthelp "NOTICE $mafs(curchannel) :$w" 	
	
	}
proc maf:not2 {n w} {
 global mafs
 puthelp "NOTICE $n :$w" 	
	}	
	
	
#proc maf:msg {n w} {
#putquick "PRIVMSG $n :$w" 	
#}
proc maf:msg {n w} {
	global msglist
set msglist [lappend msglist "PRIVMSG $n :$w"]
}

#proc maf:msgq {n w} {
#putquick "PRIVMSG $n :$w" 	
#}
proc maf:msgq {n w} {
	global msglist
set msglist [lappend msglist "PRIVMSG $n :$w"]
}


proc maf:msge {n w} {
puthelp "PRIVMSG $n :$w" 	
}


proc isnum {string} {
  if {([string compare "" $string]) && \
      (![regexp \[^0-9\] $string])} then {
    return 1
  }
  return 0
}
 
 
 #      tcl    
 #             
 #  id     
 # "   "
 proc ms:fl {n} {
  regsub -all \\\[ $n !2 n; regsub -all \\\] $n !3 n
  regsub -all \\\{ $n !5 n; regsub -all \\\} $n !4 n
  regsub -all \\\^ $n !6 n; regsub -all \\\" $n !7 n
  regsub -all \\\\ $n !1 n; return $n
}

proc ms:dfl {n} {
  regsub -all !1 $n \\ n; regsub -all !2 $n \[ n
  regsub -all !3 $n \] n; regsub -all !4 $n \} n
  regsub -all !5 $n \{ n; regsub -all !6 $n \^ n
  regsub -all !7 $n \" n; return $n
}

proc usrsay {n t} {
  puthelp "NOTICE $n :$t"
}

proc makeid {n} {
  return [tolower [ms:fl [string tolower $n]]]
} 

#      mafnicks 
# 
#0-nick #1-host #2-pass #3-identify #4-nextlink 
#5-mainlink #6-info #7-regtime #8-identtime 
#9-unidenttime #10-levelby #11-addprot #12-level


proc maf:getinfo {name id} {
	global mafnicks
	set id [tolower [ms:fl $id]]
	if {![array exist mafnicks]} {return 0}
	if {![info exist mafnicks($id)]} {return 0}
	
	switch $name {
		nick {return [lindex $mafnicks($id) 0]}
		host {return [lindex $mafnicks($id) 1]}
		pass {return [lindex $mafnicks($id) 2]}
		ident {return [lindex $mafnicks($id) 3]}
		identify {return [lindex $mafnicks($id) 3]}
		nextlink {return [lindex $mafnicks($id) 4]}
		mainlink {return [lindex $mafnicks($id) 5]}
		info {return [lindex $mafnicks($id) 6]}
		regtime {return [lindex $mafnicks($id) 7]}
		identtime {return [lindex $mafnicks($id) 8]}
		unidenttime {return [lindex $mafnicks($id) 9]}
		levelby {return [lindex $mafnicks($id) 10]}
		addprot {return [lindex $mafnicks($id) 11]}
		level {return [lindex $mafnicks($id) 12]}
		sex {return [lindex $mafnicks($id) 13]}
		}

	
	
	return 
	}

proc maf:setinfo {name id arg} {
	global mafnicks
	set id [tolower [ms:fl $id]]
	if {![array exist mafnicks]} {return 0}
	if {![info exist mafnicks($id)]} {return 0}
	
	switch $name {
		nick {set mafnicks($id) [lreplace $mafnicks($id) 0 0 $arg]}
		host {set mafnicks($id) [lreplace $mafnicks($id) 1 1 $arg]}
		pass {set mafnicks($id) [lreplace $mafnicks($id) 2 2 $arg]}
		ident {set mafnicks($id) [lreplace $mafnicks($id) 3 3 $arg]}
		identify {set mafnicks($id) [lreplace $mafnicks($id) 3  $arg]}
		nextlink {set mafnicks($id) [lreplace $mafnicks($id) 4 4 $arg]}
		mainlink {set mafnicks($id) [lreplace $mafnicks($id) 5 5 $arg]}
		info {set mafnicks($id) [lreplace $mafnicks($id) 6 6 $arg]}
		regtime {set mafnicks($id) [lreplace $mafnicks($id) 7 7 $arg]}
		identtime {set mafnicks($id) [lreplace $mafnicks($id) 8 8 $arg]}
		unidenttime {set mafnicks($id) [lreplace $mafnicks($id) 9 9 $arg]}
		levelby {set mafnicks($id) [lreplace $mafnicks($id) 10 10 $arg]}
		addprot {set mafnicks($id) [lreplace $mafnicks($id) 11 11 $arg]}
		level {set mafnicks($id) [lreplace $mafnicks($id) 12 12 $arg]}
		sex {set mafnicks($id) [lreplace $mafnicks($id) 13 13 $arg]}
		}

	
	maf:savepl
	return 
	}

#    mafstat($id) 
# 0 winners  1  scores   2  winnum  3   numgames 4 modscore

# 5  gamers  6  wasciv   7  wasmaf  8   wasman   9 wasdok     10 waskat 
# 11 wasbom  12 wasadv   13 wasdev  14  wasrep   15 washak    16 kill 
# 17 voodoo  18 voodooed 19 check   20  heal     21 fuck      22 protect 
# 23 killed  24 checked  25 healed  26  fucked   27 protected 28 civkill 
# 29 goloyes 30 golono   31 botkill 


	
proc maf:getstat {name id} {
	global mafnicks mafstat
	set id [tolower [ms:fl $id]]
	if {![array exist mafstat]} {return }
	if {![info exist mafstat($id)]} {return }
	
	switch $name {
		winners {return [lindex $mafstat($id) 0]}
		scores {return [lindex $mafstat($id) 1]}
		winnum {return [lindex $mafstat($id) 2]}
		numgames {return [lindex $mafstat($id) 3]}
		modscore {return [lindex $mafstat($id) 4]}
		gamers {return [lindex $mafstat($id) 5]}
		
		wasciv {return [lindex $mafstat($id) 6]}
		wasmaf {return [lindex $mafstat($id) 7]}
		wasman {return [lindex $mafstat($id) 8]}
		wasdok {return [lindex $mafstat($id) 9]}
		waskat {return [lindex $mafstat($id) 10]}
		wasbom {return [lindex $mafstat($id) 11]}
		wasadv {return [lindex $mafstat($id) 12]}
		wasdev {return [lindex $mafstat($id) 13]}
		wasrep {return [lindex $mafstat($id) 14]}
		washak {return [lindex $mafstat($id) 15]}
		
		kill {return [lindex $mafstat($id) 16]}
		voodoo {return [lindex $mafstat($id) 17]}
		voodooed {return [lindex $mafstat($id) 18]}
		check {return [lindex $mafstat($id) 19]}
		heal {return [lindex $mafstat($id) 20]}
		fuck {return [lindex $mafstat($id) 21]}
		protect {return [lindex $mafstat($id) 22]}
		killed {return [lindex $mafstat($id) 23]}
		checked {return [lindex $mafstat($id) 24]}
		healed {return [lindex $mafstat($id) 25]}
		fucked {return [lindex $mafstat($id) 26]}
		protected {return [lindex $mafstat($id) 27]}
		civkill {return [lindex $mafstat($id) 28]}
		goloyes {return [lindex $mafstat($id) 29]}
		golono {return [lindex $mafstat($id) 30]}
		botkill {return [lindex $mafstat($id) 31]}
		sex {return [lindex $mafstat($id) 32]}
	
		}
	return 
	}
	
proc maf:setstat {name id arg} {
	global mafnicks mafstat
	set id [tolower [ms:fl $id]]
	if {![array exist mafstat]} {return }
	if {![info exist mafstat($id)]} {return }
	
	switch $name {
		winners {set mafstat($id) [lreplace $mafstat($id) 0 0 $arg]}
		scores {set mafstat($id) [lreplace $mafstat($id) 1 1 $arg]}
		winnum {set mafstat($id) [lreplace $mafstat($id) 2 2 $arg]}
		numgames {set mafstat($id) [lreplace $mafstat($id) 3 3 $arg]}
		modscore {set mafstat($id) [lreplace $mafstat($id) 4 4 $arg]}
		gamers {set mafstat($id) [lreplace $mafstat($id) 5 5 $arg]}
		
		wasciv {set mafstat($id) [lreplace $mafstat($id) 6 6 $arg]}
		wasmaf {set mafstat($id) [lreplace $mafstat($id) 7 7 $arg]}
		wasman {set mafstat($id) [lreplace $mafstat($id) 8 8 $arg]}
		wasdok {set mafstat($id) [lreplace $mafstat($id) 9 9 $arg]}
		waskat {set mafstat($id) [lreplace $mafstat($id) 10 10 $arg]}
		wasbom {set mafstat($id) [lreplace $mafstat($id) 11 11 $arg]}
		wasadv {set mafstat($id) [lreplace $mafstat($id) 12 12 $arg]}
		wasdev {set mafstat($id) [lreplace $mafstat($id) 13 13 $arg]}
		wasrep {set mafstat($id) [lreplace $mafstat($id) 14 14 $arg]}
		washak {set mafstat($id) [lreplace $mafstat($id) 15 15 $arg]}
		
		kill {set mafstat($id) [lreplace $mafstat($id) 16 16 $arg]}
		voodoo {set mafstat($id) [lreplace $mafstat($id) 17 17 $arg]}
		voodooed {set mafstat($id) [lreplace $mafstat($id) 18 18 $arg]}
		check {set mafstat($id) [lreplace $mafstat($id) 19 19 $arg]}
		heal {set mafstat($id) [lreplace $mafstat($id) 20 20 $arg]}
		fuck {set mafstat($id) [lreplace $mafstat($id) 21 21 $arg]}
		protect {set mafstat($id) [lreplace $mafstat($id) 22 22 $arg]}
		killed {set mafstat($id) [lreplace $mafstat($id) 23 23 $arg]}
		checked {set mafstat($id) [lreplace $mafstat($id) 24 24 $arg]}
		healed {set mafstat($id) [lreplace $mafstat($id) 25 25 $arg]}
		fucked {set mafstat($id) [lreplace $mafstat($id) 26 26 $arg]}
		protected {set mafstat($id) [lreplace $mafstat($id) 27 27 $arg]}
		civkill {set mafstat($id) [lreplace $mafstat($id) 28 28 $arg]}
		goloyes {set mafstat($id) [lreplace $mafstat($id) 29 29 $arg]}
		golono {set mafstat($id) [lreplace $mafstat($id) 30 30 $arg]}
		botkill {set mafstat($id) [lreplace $mafstat($id) 31 31 $arg]}
		sex {set mafstat($id) [lreplace $mafstat($id) 32 32 $arg]}
	
		}
	return 
	}	
	
	

proc tolower {str} {
    return [string tolower [string map {                                                                 } $str]]
}
	
	
proc getmafnum {n} {
	global mafs mafmsg
	set i 0
foreach e $mafs(gmaf) {
	incr i
	if {$e==$n} {set j $i}
	 }
	 if {$i==0} {set j 0}	
	return $j
		}	
		
proc expr2 {size args} {
     if {$size == "-"} {
         return [expr $args]
     } else {
         return [format "%.${size}f" [expr $args]]
     }
}
		
		
proc xformat3 {str sex args} {
    for {set j 1} {$j <= [llength $sex]} {incr j} {
        set tmp "&s${j}:"
        while {[string first $tmp $str] != -1} {
            set i1 [string first $tmp $str]
            set i2 [string first : $str [expr $i1 + 4]]
            set i3 [string first : $str [expr $i2 + 1]]
            #set i4 [string first : $str [expr $i3 + 1]]
            if {($i1 == -1) || ($i2 == -1) || ($i3 == -1) } {
                putlog "xformatbug"
                break
            }

            switch [lindex $sex [expr $j - 1]] {
                0 { set end [string range $str [expr $i1 + 4] [expr $i2 - 1]] }
                #1 { set end [string range $str [expr $i2 + 1] [expr $i3 - 1]] }
                default { set end [string range $str [expr $i2 + 1] [expr $i3 - 1]] }
            }
            set str [string replace $str $i1 $i3 $end]
        }
    }
    set end ""
    foreach nn $args {
        set end [lappend end [string map {\\\{ \{ \\\} \} \\\[ \[ \\\] \] \\\$ \$ \\\" \"} $nn]]
    }
    set end "format \$str $end"
    return [eval $end]
}



proc delaymsg {} {
	global msglist 
	foreach e [utimers] {if {[string first "delaymsg" $e]!=-1} {killutimer [lindex $e 2]}}	
	set tdel 1
	if {[llength $msglist]>6} {set tdel 2}
	
	if {$msglist==""} {
		utimer 5 delaymsg 
		return 
		}
		#putlog "[llength $msglist]"
	putquick [lindex $msglist 0]
	
	if {[llength $msglist]>1} {
		set msglist [lrange $msglist 1 end] 
		} else {set msglist ""}
	
	utimer 1 delaymsg
	}
	
proc sexx {id} {
	global mafnicks
	#if {![info exist mafnicks($id)]} {return 0}
	set i [maf:getstat sex $id]
	if {$i!=1} {return 0
	 } else {return 1}
	
	}


proc maf:recount {} {
	global mafs
	set mafs(numplayers) [llength $mafs(players)]
	set mafs(numciv) 0
	set mafs(numkat) 0
	set mafs(nummaf) 0
	set mafs(numman) 0
	set mafs(numdok) 0
	set mafs(numbom) 0
	set mafs(numdev) 0
	set mafs(numadv) 0
	set mafs(numrep) 0
	set mafs(numhak) 0
	foreach id $mafs(players) {
		if {[role $id]==0} {incr mafs(numciv)}
		if {[role $id]==1} {incr mafs(numkat)}
		if {[role $id]==2} {incr mafs(nummaf)}
		if {[role $id]==3} {incr mafs(numman)}
		if {[role $id]==4} {incr mafs(numdok)}
		if {[role $id]==5} {incr mafs(numbom)}
		if {[role $id]==6} {incr mafs(numdev)}
		if {[role $id]==7} {incr mafs(numadv)}
		if {[role $id]==8} {incr mafs(numrep)}
		if {[role $id]==9} {incr mafs(numhak)}
		
		}
	
	
	
	}
	
	
proc maf:showdccroles {} {
	global mafmsgr mafreals mafs
	foreach id $mafs(players) {
		putlog "$mafreals($id) = $mafmsgr([role $id])"
		
		}
	
	
	}
	
	
proc maf:callfunc {t} {
	#putlog "$t"
	#putlog "[catch $t gg]"
	if {[catch "$t" gg]!=0} {
		maf:say "4  . - 12 $t. 04 12$gg"
		maf:msg "X-Evil" "X-EVIL 4  . - 12 $t.04  12 $gg"
		putlog "4  . - 12 $t. 04 12$gg"
		return
		}
	putlog "success $t"
	}
	
proc randmsg {} {
	global mafmsg
	#unset mafmsg
	source "scripts/mafbot/mafmsgs.tcl"
	
       }
